<?xml version="1.0" encoding="UTF-8"?>
<xbl:template xmlns:xbl="http://schemas.niku.com/2002/xbl">

  <xbl:include href="common_include.xbl" component="xog"/>
  <xbl:function name="xogGetCalendarHPD" class="com.niku.xog.functions.XOGGetCalendarHPD"/>
  <xbl:function name="xogValidateTimezone" class="com.niku.xog.util.XOGValidateTimezone"/>
  <xbl:function name="xogValidateLocale" class="com.niku.xog.util.XOGValidateLocale"/>
  <!--<xbl:query name="parentdocument" source="xml:file:///d:/niku/xog/src/webroot/WEB-INF/xog/xml/cmn_users_write.xml"/>-->
  <xbl:query name="parentdocument" source="xml:input"/>
  <!-- global variables that only needs to be set once -->
  <!-- niku2000 value -->
  <xbl:variable name="pwdval" value="I2ynHl2NedlGqce2b0AhPh+rojNz3DC0vza/qhEupws="/>
  <xbl:variable name="emptypval" value=""/>
  <xbl:xogwarn>
    <Severity>WARNING</Severity>
    <Description>New Users Password will be Defaulted to Value senthil2</Description>
    <column name="ALL">ALL RECORDS</column>
  </xbl:xogwarn>
  <xbl:for-each name="document" select="parentdocument[NikuDataBus]">
    <!-- This section is to create values for externalsource Id's-->
    <xbl:for-each name="srcHeader" select="document.children[Header]">
      <xbl:variable name="proceed" value="0"/>
      <xbl:xogtry>
        {xogaddwarning('initialize')}
        <xbl:variable name="external_source_id" value=""/>
        <xbl:query name="external_source_id_vals" source="pmd" value="xog.externalSourceId">
          <xbl:parameter name="sourceId" value="{srcHeader.externalSource}" type="string"/>
        </xbl:query>
        <xbl:variable name="external_source" value="{srcHeader.externalSource}"/>
        <xbl:for-each select="external_source_id_vals">
          <xbl:variable name="external_source_id" value="{id}"/>
        </xbl:for-each>
        <xbl:if test="{$external_source_id =null}">
          <xbl:xogcontinue> The External Source {srcHeader.externalSource} Provided is Invalid.</xbl:xogcontinue>
          <xbl:else>
            <xbl:variable name="proceed" value="1"/>
          </xbl:else>
        </xbl:if>
        <xbl:catch>
          <Severity>FATAL</Severity>
          <Description>Problem In Header Data.No Records Could Be Inserted.</Description>
        </xbl:catch>
      </xbl:xogtry>
      <xbl:variable name="warnValue" value="{xogaddwarning('retrieveWarning')}"/>
      <xbl:if test="{$warnValue!=1}">
        <xbl:xogwarn>
          <Severity>WARNING</Severity>
          <Description>{xogaddwarning('retrieveWarning')}</Description>
        </xbl:xogwarn>
      </xbl:if>
    </xbl:for-each>
    <xbl:variable name="updatedRecords" value="0"/>
    <xbl:if test="{$proceed!=0}">
      <xbl:for-each name="srcUsers" select="document.children[Users]">
        <xbl:for-each name="srcRecord" select="srcUsers.children[User]">
          {xogaddwarning('initialize')}
          <xbl:xogtry>
            <!-- ****** 1 ***. IMPORTANT reset to empty at beginning of each loop to avoid inherit value from previous loop -->
            <xbl:variable name="usertypval" value=""/>

            <!-- the following 2:
                    userstval -   cmn_sec_users
                    isactiveval - srm_resources
            -->
            <xbl:variable name="userstval" value=""/>
            <xbl:variable name="isactiveval" value=""/>

            <xbl:variable name="langidval" value=""/>
            <xbl:variable name="locidval" value=""/>
            <xbl:variable name="tzidval" value=""/>

            <xbl:variable name="company_id" value=""/>
            <xbl:variable name="unamecheck" value=""/>
            <xbl:variable name="resId" value=""/>
            <xbl:variable name="external_id" value=""/>
            <xbl:variable name="unique_name" value=""/>
            <xbl:variable name="firstname" value=""/>
            <xbl:variable name="lastname" value=""/>
            <xbl:variable name="emailAddress" value=""/>
            <xbl:variable name="homeUrl" value=""/>

            <!-- ****** 2 ***. retrieving values for this loop -->
            <xbl:for-each name="srcPersInfo" select="srcRecord.children[PersonalInformation]">
              <xbl:variable name="firstname" value="{srcPersInfo.firstName}"/>
              <xbl:variable name="lastname" value="{srcPersInfo.lastName}"/>
              <xbl:variable name="emailAddress" value="{srcPersInfo.emailAddress}"/>
              <xbl:variable name="homeUrl" value="{srcPersInfo.homeUrl}"/>
            </xbl:for-each>
            <!-- This section is to create values for createdby , createddate, modifiedby , modifieddate values-->
            <!-- Default value for Date -->
            <xbl:variable name="ADDED_DATE" value="{xogDateFormattor($now,'1')}"/>
            <!-- Default value for added by -->
            <xbl:variable name="ADDED_BY" value="{$login_user}"/>
            <xbl:for-each name="srcGeneral" select="srcRecord.children[General]">
              <xbl:variable name="BY" value="{srcGeneral.addedBy}"/>
              <xbl:if test="{$BY!=null}">
                <xbl:variable name="ADDED_BY" value="{$BY}"/>
              </xbl:if>
              <xbl:variable name="DATE" value="{srcGeneral.addedDate}"/>
              <xbl:if test="{$DATE!=null}">
                <xbl:variable name="ADDED_DATE" value="{$DATE}"/>
              </xbl:if>
            </xbl:for-each>
            <xbl:variable name="ADDED_DATE" value="{xogDateFormattor($ADDED_DATE,'0')}"/>
            <xbl:for-each name="srcResource" select="srcRecord.children[Resource]">
              <xbl:if test="{srcResource.resourceId!=null}">
                <xbl:variable name="unique_name" value="{trim(srcResource.resourceId)}"/>
              </xbl:if>
            </xbl:for-each>
            <!-- Get the internal ID for the Added By Code -->
            <xbl:query name="LOOKUP_USER_ID" source="pmd" value="xog.LoginUserID">
              <xbl:parameter name="user_name" value="{$ADDED_BY}" type="string"/>
            </xbl:query>
            <xbl:for-each select="LOOKUP_USER_ID">
              <xbl:variable name="USER_ID" value="{ID}"/>
            </xbl:for-each>
            <xbl:if test="{$USER_ID=null}">
              <xbl:xogcontinue>Added By "{$ADDED_BY}" value does not exist in the System</xbl:xogcontinue>
            </xbl:if>
            <xbl:variable name="isExternal" value="0"/>
            <xbl:if test="{srcRecord.userType='external' or srcRecord.userType='EXTERNAL'  or srcRecord.userType='External'}">
              <xbl:variable name="isExternal" value="1"/>
            </xbl:if>
            <xbl:if test="{srcRecord.userType='admin' or srcRecord.userType='ADMIN'  or srcRecord.userType='Admin'}">
              <xbl:variable name="isExternal" value="0"/>
              {xogaddwarning('The ADMIN user type is no longer available. The user type has been defaulted to INTERNAL')}
            </xbl:if>

            <!-- Section to get user status -->
            <xbl:if test="{srcRecord.userStatus != null }">
              <xbl:query name="userst" source="pmd" value="xog.resourceLookup">
                <xbl:parameter name="type" value="SEC_USER_STATUS" type="string"/>
                <xbl:parameter name="code" value="{srcRecord.userStatus}" type="string"/>
              </xbl:query>
              <xbl:for-each select="userst">
                <xbl:variable name="userstval" value="{id}"/>
                <!-- Set resource active flag as well-->
                <xbl:if test="{lookup_code = 'INACTIVE'}">
                  <xbl:variable name="isactiveval" value="0"/>
                  <xbl:else>
                    <xbl:variable name="isactiveval" value="1"/>
                  </xbl:else>
                </xbl:if>
              </xbl:for-each>
              <xbl:if test="{$userstval=null}">
                <xbl:xogcontinue>User Status Value  {srcRecord.userStatus}  Provided is Invalid</xbl:xogcontinue>
              </xbl:if>
            </xbl:if>

            <!-- Section to get language id -->
            <xbl:if test="{srcRecord.userLanguage != null }">
              <xbl:query name="langid" source="pmd" value="xog.getCmnUserLanguage" >
                <xbl:parameter name="name" value="{srcRecord.userLanguage}" />
              </xbl:query>
              <xbl:for-each select="langid">
                <xbl:choose>
                  <xbl:when test="{PK_ID = null}">
                    {xogaddwarning('userLanguage {srcRecord.userLanguage} is invalid. Hence this column data has been inserted as default value.')}
                    <xbl:variable name="langidval" value="1"/>
                  </xbl:when>
                  <xbl:otherwise>
                    <xbl:variable name="langidval" value="{PK_ID}"/>
                  </xbl:otherwise>
                </xbl:choose>
              </xbl:for-each>
            </xbl:if>

            <!-- Section to get valid timezone -->
            <xbl:if test="{xogValidateTimezone(srcRecord.userTimezone)}">
              <xbl:variable name="tzidval" value="{srcRecord.userTimezone}"/>
            </xbl:if>
            <!-- Section to get valid timezone -->
            <xbl:if test="{xogValidateLocale(srcRecord.userLocale)}">
              <xbl:variable name="locidval" value="{srcRecord.userLocale}"/>
            </xbl:if>
            <xbl:variable name="company_id" value="0"/>
            <xbl:for-each name="srcCompany" select="srcRecord.children[Company]">
              <xbl:query name="companyid" source="pmd" value="xog.getCompanyId">
                <xbl:parameter name="companyId" value="{srcCompany.companyId}" />
              </xbl:query>
              <xbl:for-each select="companyid">
                <xbl:variable name="company_id" value="{id}"/>
              </xbl:for-each>
              <xbl:if test="{srcCompany.companyId!=null OR srcCompany.companyId!=''}">
                <xbl:if test="{$company_id='0' OR $company_id =''}">
                  {xogaddwarning('Company {srcCompany.companyId} is invalid.Hence this column data has been inserted as null. ')}
                </xbl:if>
              </xbl:if>
            </xbl:for-each>
            <xbl:query name="usernamecheck" source="pmd" value="xog.userNameCheck">
              <xbl:parameter name="userName" value="{srcRecord.userName}"/>
            </xbl:query>
            <xbl:for-each select="usernamecheck">
              <!-- user exists, So use preserve info if needed for UPDATE -->
              <xbl:variable name="unamecheck" value="{id}"/>
              <xbl:variable name="uniquenamecheck" value="{unique_name}"/>
              <xbl:variable name="firstnamecheck" value="{first_name}"/>
              <xbl:variable name="lastnamecheck" value="{last_name}"/>
              <xbl:variable name="emailaddresscheck" value="{email_address}"/>
              <xbl:variable name="homeurlcheck" value="{home_url}"/>
              <xbl:variable name="isExternalCheck" value="{is_external}"/>
              <xbl:if test="{$isExternalCheck != $isExternal and $isExternal = 0}">
                <xbl:variable name="isExternal" value="{$isExternalCheck}"/>
              </xbl:if>
              <xbl:if test="{$langidval=null}">
                <xbl:variable name="langidval" value="{language_id}"/>
              </xbl:if>
              <!-- Default to US englist for insert only -->
              <xbl:if test="{$locidval=null}">
                <xbl:variable name="locidval" value="{locale}"/>
              </xbl:if>
              <xbl:if test="{$tzidval=null}">
                <xbl:variable name="tzidval" value="{timezone}"/>
              </xbl:if>

              <xbl:variable name="companycheck" value="{company_id}"/>
              <xbl:variable name="userstatuscheck" value="{user_status_id}"/>
              <xbl:variable name="uslookupcodecheck" value="{lookup_code}"/>
              <xbl:variable name="resId" value="{resource_id}"/>
            </xbl:for-each>
            <xbl:if test="{$unamecheck=null or $unamecheck=''}">
              <!-- INSERT MODE -->

              <!-- Default to ENGLISH -->
              <xbl:if test="{$langidval=null}">
                <xbl:variable name="langidval" value="1"/>
              </xbl:if>
              <!-- Default to US englist for insert only -->
              <xbl:if test="{$locidval=null}">
                <xbl:variable name="locidval" value="en_US"/>
              </xbl:if>
              <xbl:if test="{$tzidval=null}">
                <xbl:variable name="tzidval" value="Europe/London"/>
              </xbl:if>

              <!-- USER TYPE DEFAULTED TO INTERNAL IF NOT PROVIDED-->
              <xbl:variable name="internaluserid" value="{sequence('CMN_SEC_USERS','CMN_SEC_USERS_S1')}"/>
              <xbl:execute source="pmd" value="xog.insertCmnUserResource">
                <xbl:parameter name="id" value="{$internaluserid}"/>
                <xbl:parameter name="userName" value="{srcRecord.userName}"/>
                <xbl:parameter name="firstName" value="{$firstname}"/>
                <xbl:parameter name="lastName" value="{$lastname}"/>
                <xbl:parameter name="pwd" value="{$pwdval}"/>
                <xbl:parameter name="email" value="{$emailAddress}"/>
                <xbl:parameter name="status" value="{$userstval}"/>
                <xbl:parameter name="languageId" value="{$langidval}"/>
                <xbl:parameter name="locale" value="{$locidval}"/>
                <xbl:parameter name="timeZone" value="{$tzidval}"/>
                <xbl:parameter name="country" value="1"/>
                <xbl:parameter name="forcePwdChange" value="1"/>
                <xbl:parameter name="company_id" value="{$company_id}" />
                <xbl:parameter name="externalId" value="{srcRecord.externalId}"/>
                <xbl:parameter name="externalSourceId" value="{$external_source_id}"/>
                <xbl:parameter name="isLdap" value="1"/>
                <xbl:parameter name="homeUrl" value="{$homeUrl}"/>
             </xbl:execute>
              <xbl:variable name="resId" value="{counter('SRM_RESOURCES')}"/>
              <!-- Get the employee type.  Only need to get it once. -->
              <xbl:if test="{$emptypval = ''}">
                <xbl:query name="emptyp1" source="pmd" value="xog.resourceLookup">
                  <xbl:parameter name="type" value="SRM_RESOURCE_TYPE" type="string"/>
                  <xbl:parameter name="code" value="Employee" type="string"/>
                </xbl:query>
                <xbl:for-each select="emptyp1">
                  <xbl:variable name="emptypval" value="{id}"/>
                </xbl:for-each>
              </xbl:if>
              <xbl:if test="{$unique_name!=null}">
                <!-- Check whether the resource ID is already associated with any user -->
                <xbl:query name="LOOKUP_RESOURCE_ID" source="pmd" value="xog.resourceInfo">
                  <xbl:parameter name="uniqueName" value="{$unique_name}" type="string"/>
                </xbl:query>
                <xbl:for-each select="LOOKUP_RESOURCE_ID">
                  <xbl:xogcontinue>Resource {$unique_name} already associated with another user. Please use an unique resourceId.</xbl:xogcontinue>
                </xbl:for-each>
              </xbl:if>
              <!-- if no resource id, then use the user name -->
              <xbl:if test="{$unique_name=null}">
                <xbl:variable name="unique_name" value="{trim(srcRecord.userName)}"/>
              </xbl:if>
              <!--
              Set the user id variable for later use
              -->
              <xbl:variable name="unamecheck" value="{$internaluserid}"/>
              <xbl:variable name="fullName" value="{$lastname}, {$firstname}"/>
              <xbl:execute source="pmd" value="xog.insertCmnUserSRMResource">
                <xbl:parameter name="id" value="{$resId}"/>
                <xbl:parameter name="lastName" value="{$lastname}"/>
                <xbl:parameter name="firstName" value="{$firstname}"/>
                <xbl:parameter name="uniqueName" value="{$unique_name}"/>
                <xbl:parameter name="email" value="{$emailAddress}"/>
                <xbl:parameter name="personType" value="{$emptypval}"/>
                <xbl:parameter name="isActive" value="{$isactiveval}"/>
                <xbl:parameter name="isExternal" value="{$isExternal}"/>
                <xbl:parameter name="externalSourceID" value="{$external_source_id}"/>
                <xbl:parameter name="externalId" value="{srcRecord.externalId}"/>
                <xbl:parameter name="resType" value="0"/>
                <xbl:parameter name="userId" value="{$internaluserid}"/>
                <xbl:parameter name="fullName" value="{$fullName}"/>
              </xbl:execute>
              
               <!-- Moved the SRM_RESOURCES_DMS_FOLDERS_T1 code to this xbl  -->
              <xbl:call href="createFolderForNewResource.xbl" component="dms">
                <xbl:call-param name="pk" value="{$resId}" type="in"/>
                <xbl:call-param name="unique_name" value="{$unique_name}" type="in"/>
              </xbl:call>
              
              <xbl:query name="qCalendar" source="pmd" value="xog.getStandardCalendar"/>
              <xbl:match name="calendar" select="qCalendar">
                <xbl:variable name="calendarId" value="{prid}"/>
                <xbl:variable name="calhpd" value="{xogGetCalendarHPD('calendar')}"/>
              </xbl:match>
              <xbl:if test="{$calendarId =null}">
                <xbl:xogcontinue>Standard Calendar Does not Exist</xbl:xogcontinue>
              </xbl:if>
              <xbl:execute source="pmd" value="xog.insertCmnUserPRJResource">
                <xbl:parameter name="uid" value="{xogblob('prUID')}"/>
                <xbl:parameter name="id" value="{$resId}"/>
                <xbl:parameter name="isOpen" value="0"/>
                <xbl:parameter name="trackMode" value="0"/>
                <xbl:parameter name="calendarId" value="{$calendarId}"/>
                <xbl:parameter name="isRole" value="0"/>
              </xbl:execute>
              <xbl:query name="availcurve" source="pmd" table="PRJ_RESOURCES" value="xog.getResourceCurve">
                <xbl:parameter name="resourceId" value="{$resId}"/>
              </xbl:query>
              <xbl:variable name="dap" value="100"/>
              <xbl:for-each name="updateavailcurve" select="availcurve">
                <xbl:update blockInstaSlice="{boolean('true')}">
                  <!--xbl:variable name="setblob" value="{xogblob('prAvailCurve','{$dap}','PRAVAILCURVE','false')}"/-->
                  <!-- create the availcurve for a labor type resource -->
                  <xbl:variable name="setblob" value="{xogblob('prAvailCurve','{$dap}','PRAVAILCURVE','false',$calhpd,0)}"/>
                </xbl:update>
              </xbl:for-each>
              <!-- Set the auto rights -->
              <xbl:execute name="autoRights" source="pmd" value="xog.grantInstanceRight">
                <xbl:parameter name="principalType" value="USER"/>
                <xbl:parameter name="userName" value="{srcRecord.userName}"/>
                <xbl:parameter name="rightName" value="ResourceEnterTime"/>
                <xbl:parameter name="objectID" value="{$resId}"/>
              </xbl:execute>
              <xbl:execute name="autoRights2" source="pmd" value="xog.grantInstanceRight">
                <xbl:parameter name="principalType" value="USER"/>
                <xbl:parameter name="userName" value="{srcRecord.userName}"/>
                <xbl:parameter name="rightName" value="ResourceSelf"/>
                <xbl:parameter name="objectID" value="{$resId}"/>
              </xbl:execute>
            <xbl:else>
                <!-- UPDATE MODE -->
                <xbl:if test="{$firstname=null}">
                  <xbl:variable name="firstname" value="{$firstnamecheck}"/>
                </xbl:if>
                <xbl:if test="{$lastname=null}">
                  <xbl:variable name="lastname" value="{$lastnamecheck}"/>
                </xbl:if>
                <xbl:if test="{$emailAddress=null}">
                  <xbl:variable name="emailAddress" value="{$emailaddresscheck}"/>
                </xbl:if>
                <xbl:if test="{$homeUrl=null}">
                  <xbl:variable name="homeUrl" value="{$homeurlcheck}"/>
                </xbl:if>
                <xbl:if test="{$company_id=0 and $companycheck != null}">
                  <xbl:variable name="company_id" value="{$companycheck}"/>
                </xbl:if>
                <xbl:if test="{$userstval=null}">
                  <xbl:variable name="userstval" value="{$userstatuscheck}"/>
                  <!-- Set resource active flag as well-->
                  <xbl:choose>
                    <xbl:when test="{$uslookupcodecheck = 'INACTIVE'}">
                      <xbl:variable name="isactiveval" value="0"/>
                    </xbl:when>
                    <xbl:otherwise>
                      <xbl:variable name="isactiveval" value="1"/>
                    </xbl:otherwise>
                  </xbl:choose>
                </xbl:if>
                <xbl:if test="{$tzidval=null}">
                  <xbl:variable name="tzidval" value="{$timezonecheck}"/>
                </xbl:if>
                <xbl:if test="{$unique_name=null}">
                  <xbl:variable name="unique_name" value="{$uniquenamecheck}"/>
                </xbl:if>
              <xbl:execute source="pmd" value="xog.updateCmnUserResource">
                <xbl:parameter name="firstName" value="{$firstname}"/>
                <xbl:parameter name="lastName" value="{$lastname}"/>
                <xbl:parameter name="email" value="{$emailAddress}"/>
                <xbl:parameter name="status" value="{$userstval}"/>
                <xbl:parameter name="languageId" value="{$langidval}"/>
                <xbl:parameter name="company_id" value="{$company_id}" />
                <xbl:parameter name="timeZone" value="{$tzidval}"/>
                <xbl:parameter name="locale" value="{$locidval}"/>
                <xbl:parameter name="id" value="{$unamecheck}" />
                <xbl:if test="{$homeUrl!='default'}">
                  <xbl:parameter name="homeUrl" value="{$homeUrl}" />
                </xbl:if>
              </xbl:execute>
                <!-- if no resource id, then use the user name -->
                <!-- xbl:if test="{$unique_name!=null and $unique_name!=''}">
                  <xbl:query name="LOOKUP_RES_ID" source="jdbc">
                    select ID from SRM_RESOURCES where UNIQUE_NAME = '{$unique_name}'
                  </xbl:query -->
                <!-- xbl:for-each select="LOOKUP_RES_ID">
                    <xbl:variable name="resId" value="{ID}"/>
                  </xbl:for-each -->
                <!-- If the unique_name ( resource association) in the db is not equal to the one passed then validate before using the new one -->
                <xbl:if test="{$unique_name!=null}">
                  <xbl:if test="{$uniquenamecheck != $unique_name}">
                    <!-- Check whether the resource ID is already associated with any user -->
                    <xbl:query name="LOOKUP_RESOURCE_ID" source="pmd" value="xog.resourceInfo">
                      <xbl:parameter name="uniqueName" value="{$unique_name}" type="string"/>
                    </xbl:query>
                    <xbl:for-each select="LOOKUP_RESOURCE_ID">
                      <xbl:xogcontinue>Resource {$unique_name} already associated with another user. Please use an unique resourceId.</xbl:xogcontinue>
                    </xbl:for-each>
                       <!-- Check whether the resource is finanical enabled -->
					<xbl:variable name="pacResId" value=""/>
					<xbl:query name="pacRes" source="pmd" value="xog.getPacMntId">
						<xbl:parameter name="id" value="{$resId}"/>
					</xbl:query>
					<xbl:match select="pacRes">
					    <xbl:variable name="pacResId" value="{id}"/>
					</xbl:match>
					<xbl:if test="{$pacResId != null OR $pacResId != '' }">
						<xbl:variable name="unique_name" value="{$uniquenamecheck}"/>
					    {xogaddwarning('Resource {$uniquenamecheck} is financial enabled. Resource ID is not updated. ')}
					</xbl:if>
                  </xbl:if>
                </xbl:if>
                <xbl:debug value="unique_name= {$unique_name}:{$resId}"/>
              	<xbl:variable name="fullName" value="{$lastname}, {$firstname}"/>
                <xbl:execute source="pmd" value="xog.updateCmnUserSRMResource">
                    <xbl:parameter name="lastName" value="{$lastname}" />
                    <xbl:parameter name="firstName" value="{$firstname}" />
                    <xbl:parameter name="email" value="{$emailAddress}" />
                    <xbl:parameter name="isActive" value="{$isactiveval}" />
                    <xbl:parameter name="fullName" value="{$fullName}" />
                    <xbl:parameter name="isExternal" value="{$isExternal}"  />
                    <xbl:parameter name="uniqueName" value="{$unique_name}" />
                    <xbl:parameter name="user_id" value="{$unamecheck}" />
                </xbl:execute>
                <!-- /xbl:if -->
                <xbl:variable name="updatedRecords" value="{{integer($updatedRecords)} + 1}"/>
              </xbl:else>
            </xbl:if>
            <!-- This is for Updating/Inserting CDF's-->
            <xbl:variable name="INTERNAL_ID" value="{$resId}"/>
            <xbl:variable name="ADDED_DATE" value="{$now}"/>
            <!-- odf_pk and odf_object_code variables are required in the odf instance xog -->
            <xbl:variable name="odf_pk" value="{$INTERNAL_ID}"/>
            <xbl:variable name="odf_object_code" value="resource"/>
            <xbl:include href="odf_instance_write_include.xbl" component="xog"/>
            <!--
             Update the OBS associations for the user
             -->
            <xbl:variable name="table_name" value="SRM_RESOURCES"/>
            <xbl:variable name="record_id" value="{$resId}"/>
            <xbl:include href="obs_assoc_write_include.xbl" component="xog"/>
            <!-- ***********************************************
                  If obs associations where made, get the entity code.
                 ***********************************************
            -->
            <xbl:if test="{$obsUnitId != null and $obsUnitId != ''}">  
            <xbl:query name="departmentLookup" source="pmd" value="xog.findDepartment">
              <xbl:parameter name="obsUnitId" value="{$obsUnitId}"/>
              <xbl:parameter name="table_name" value="{$table_name}"/>
            </xbl:query>
            <xbl:match name="deptData" select="departmentLookup">
              <xbl:variable name="dept_code" value="{deptData/@departcode}"/>
            </xbl:match>

            <xbl:query name="locationIdLookup" source="pmd" value="xog.findLocation">
              <xbl:parameter name="obsUnitId" value="{$obsUnitId}"/>
              <xbl:parameter name="table_name" value="{$table_name}"/>
            </xbl:query>
            <xbl:match name="locData" select="locationIdLookup">
              <xbl:variable name="locid" value="{locData/@locationid}"/>
            </xbl:match>


            <xbl:if test="{$dept_code != '' and $dept_code != null}">
              <xbl:query name="getEntityByDepartment" source="pmd" value="revmgr.getEntityNameByDepartmentCode">
                <xbl:parameter name="departcode" value="{$dept_code}"/>
              </xbl:query>
              <xbl:match name="dept_entityCode" select="getEntityByDepartment">
                <xbl:variable name="dept_entity" value="{dept_entityCode/@entity}"/>
              </xbl:match>
            </xbl:if>
            <xbl:if test="{$locid != '' and $locid != null}">

              <xbl:query name="getEntityByLocation" source="pmd" value="revmgr.geEntityNameByLocationID">
                <xbl:parameter name="locationId" value="{$locid}"/>
              </xbl:query>
              <xbl:match name="loc_entityCode" select="getEntityByLocation">
                <xbl:variable name="loc_entity" value="{loc_entityCode/@entity}"/>
              </xbl:match>
            </xbl:if>
            <!--
             Assert that the entity code of both location and department are the same.
            -->
            <xbl:variable name="entity_code" value=""/>
            <xbl:if test="{$dept_entity != '' and $dept_entity != null}">
              <xbl:if test="{$loc_entity != '' and $loc_entity != null}">
                <xbl:if test="{$dept_entity == $loc_entity}">
                  <xbl:variable name="entity_code" value="{$loc_entity}"/>
                  <xbl:else>
                    <!-- todo: throw an exception: 'Location and Department must have the same entity' -->
                  </xbl:else>
                </xbl:if>
                <xbl:else>
                  <xbl:variable name="entity_code" value="{$dept_entity}"/>
                </xbl:else>
              </xbl:if>
              <xbl:else>
                <xbl:variable name="entity_code" value="{$loc_entity}"/>
              </xbl:else>
            </xbl:if>
            <!-- Update entity_code in srm_resource for current resource -->
              <xbl:execute source="pmd" value="xog.updateResourceEntityCode">
                <xbl:parameter name="id" value="{$resId}"/>
                <xbl:parameter name="entity_code" value="{$entity_code}"/>
             </xbl:execute>
            </xbl:if> 
            <!-- **********************************************************  -->
            <!--
            Update the Group assocations for the user
            -->
            <xbl:variable name="user_record_id" value="{$unamecheck}"/>
            <xbl:include href="group_write_include.xbl" component="xog"/>
            <!--
            Update the Global Rights for the user
            -->
            <xbl:include href="global_right_write_include.xbl" component="xog"/>
            <!--
            Update the Instance Rights for the user
            -->
   					<xbl:variable name="principal_type" value="USER"/>
            <xbl:include href="instance_right_write_include.xbl" component="xog"/>
            <!--
            Update the Instance OBS Rights for the user
            -->
            <xbl:include href="obs_right_write_include.xbl" component="xog"/>
            <!-- Committing Every Successful Transaction-->
            <xbl:xogdsn source="jdbc" action="commit"/>
            <xbl:catch>
              <Severity>FATAL</Severity>
              <Description>This record has not been inserted</Description>
              <column name="externalSource">{$external_source}</column>
              <column name="externalId">{srcRecord.externalId}</column>
              <column name="userName">{srcRecord.userName}</column>
              <!-- Rolling Back Every Error Transaction-->
              <xbl:xogdsn source="jdbc" action="rollback"/>
            </xbl:catch>
          </xbl:xogtry>
          <xbl:variable name="warnValue" value="{xogaddwarning('retrieveWarning')}"/>
          <xbl:if test="{$warnValue!='1'}">
            <xbl:xogwarn>
              <Severity>WARNING</Severity>
              <Description>{xogaddwarning('retrieveWarning')}</Description>
              <column name="externalSource">{$external_source}</column>
              <column name="externalId">{srcRecord.externalId}</column>
              <column name="userName">{srcRecord.userName}</column>
            </xbl:xogwarn>
          </xbl:if>
        </xbl:for-each>
      </xbl:for-each>
    </xbl:if>
  </xbl:for-each>
  <xbl:xogstats updatedRecords="{$updatedRecords}"/>
</xbl:template>
